<?php
/**
 * Compose message
 *
 * Copyright 2007 Obala d.o.o. (www.obala.si)
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://cvs.horde.org/co.php/news/LICENSE.
 *
 * $Id: ajaxcompose.php 161 2008-01-03 16:19:14Z duck $
 *
 * @author Duck <duck@obala.net>
 * @package Usms
 */

define('USMS_BASE', dirname(__FILE__));
require_once USMS_BASE . '/lib/base.php';
require_once USMS_BASE . '/lib/Forms/ComposeAjax.php';
require_once 'Horde/Variables.php';

// Cancelled?
if (Util::getFormData('submitbuttom') == _("Close")) {
    echo '<script type="text/javascript">RedBox.close();</javascript>';
}

// From
$vars = Variables::getDefaultVariables();
$form = new Usms_ComposeAjax_Form($vars, '');

if ($form->validate()) {
    $form->getInfo(null, $info);
    $info['content'] = ($prefs->getValue('richtext')) ? trim($info['content']) : trim(strip_tags($info['content']));
    $to = explode(', ', $info['user_to']);
    $result = $usms->sendMessage($to, $info);
    if ($result instanceof PEAR_Error) {
        $notification->push($result->getMessage(), 'horde.error');
    }

    if (empty($info['url'])) {
        $info['url'] = empty($_SERVER['HTTP_REFERER']) ? Horde::applicationUrl('browse.php') : $_SERVER['HTTP_REFERER'];
    }

    header('Location: ' . $info['url']);
    exit;
}

$notification->notify(array('listeners' => 'status'));
$form->renderActive(null, null, Horde::selfUrl(), 'post');

