<?php
/**
 * Compose message
 *
 * Copyright 2007 Obala d.o.o. (www.obala.si)
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://cvs.horde.org/co.php/news/LICENSE.
 *
 * $Id: compose.php 311 2008-01-31 16:15:38Z duck $
 *
 * @author Duck <duck@obala.net>
 * @package Usms
 */

define('USMS_BASE', dirname(__FILE__));
require_once USMS_BASE . '/lib/base.php';
require_once USMS_BASE . '/lib/Forms/Compose.php';
require_once 'Horde/Variables.php';

$title = _("Compose");
$id = Util::getFormData('id');
$actionID = Util::getFormData('actionID');

$vars = Variables::getDefaultVariables();
$form = new Usms_Compose_Form($vars, $title);

/* process */
if ($form->validate()) {

    $form->getInfo($vars, $info);
    $info['content'] = ($prefs->getValue('richtext_composon')) ? trim($info['content']) : trim(strip_tags($info['content']));
    $to = explode(', ', $info['user_to']);
    $result = $usms->sendMessage($to, $info);
    if ($result instanceof PEAR_Error) {
        $notification->push($result->getMessage(), 'horde.error');
    } else {
        header('Location:' . Horde::applicationUrl('browse.php'));
        exit;
    }

} elseif ($id > 0) {

    $folder = Util::getFormData('folder');
    $message = $usms->getMessage($id, $folder);
    if ($message instanceof PEAR_Error) {
        $notification->push($message->getMessage(), 'horde.error');
        header('Location: ' . Horde::applicationUrl('browse.php'));
        exit;
    }

    $form->addHidden('', 'id', 'int', true);
    $vars->set('id', $id);

    $form->addHidden('user_from', 'user_from', 'int', true);
    $vars->set('user_from', $message['user']);

    $message['content'] = str_replace("\n", "\n> ", strip_tags($message['content']));
    $message['content'] = wordwrap($message['content'], 55, "\n> ");
    $message['content'] = " \n\n" . $message["user"] . sprintf(_(" at %s wrote:"), date('r', Usms::index($id))) . "\n----------------------------------------\n> " .  $message['content'];
    $vars->set('content', $message['content']);

    if ($actionID == 'replay') {
        $vars->set('title', 'RE: ' . $message['title']);
        $vars->set('user_to', $message['user']);
    } elseif ($actionID == "forward") {
        $vars->set('title', 'FW: ' . $message['title']);
    }

}

Horde::addScriptFile('usms.js', 'usms', true);
require USMS_TEMPLATES . '/common-header.inc';
require USMS_TEMPLATES . '/menu.inc';

echo '<div id="compose">';
$form->renderActive(null, null, null, 'post');
echo '</div>';

require $registry->get('templates', 'horde') . '/common-footer.inc';
