<?php
/**
 * Download message file
 *
 * Copyright 2007 Obala d.o.o. (www.obala.si)
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://cvs.horde.org/co.php/news/LICENSE.
 *
 * $Id: file.php 296 2008-01-28 21:07:22Z duck $
 *
 * @author Duck <duck@obala.net>
 * @package Usms
 */
$no_compress = true;
$session_control = 'readonly';
define('USMS_BASE', dirname(__FILE__));
require_once USMS_BASE . '/lib/base.php';

$actionID = Util::getFormData('actionID');
$file = Util::getGet('file');
$id  = Util::getGet('id');
$user = Util::getGet('user');
$row = $usms->readBodyData($id, $user);

/* Run through action handlers. */
switch ($actionID) {
case 'download_file':

    $filename = $row['attachments'][$file]['name'];
    $browser->downloadHeaders($filename);
    if ((readfile($usms->vfsPath($user, $id) . $file)) === false) {
        die(sprintf(_("Cannot read file %s"), $filename));
    }

break;

case 'view_file':

    $filename = $row['attachments'][$file]['name'];
    $type = $row['attachments'][$file]['type'];
    $data = file_get_contents($usms->vfsPath($user, $id) . $file);
    if ($data === false) {
        die(sprintf(_("Cannot read file %s"), $filename));
    }

    require_once 'Horde/MIME/Part.php';
    require_once 'Horde/MIME/Viewer.php';
    require_once 'Horde/MIME/Magic.php';
    require_once 'Horde/MIME/Contents.php';

    $mime = &new MIME_Part(MIME_Magic::extToMIME($type), $data);
    $mime->setName($filename);
    $contents = &new MIME_Contents($mime);
    $body = $contents->renderMIMEPart($mime);
    $browser->downloadHeaders($mime->getName(true, true), $type, true, strlen($body));
    echo $body;

break;

case 'download_zip':

    $zipfiles = array();

    if ($id) {
        $filename = $id;
        foreach ($row['attachments'] as $file => $file_data) {
            $zipfiles[] = array('data' => file_get_contents($usms->vfsPath($user, $id) . $file),
                                'name' => basename($file_data['name']));
        }
    } else {
        $filename = $row['attachments'][$file]['name'];
        $zipfiles[] = array('data' => file_get_contents($usms->vfsPath($user, $id) . $file),
                            'name' => $row['attachments'][$file]['name']);
    }

    $zip = Horde_Compress::singleton('zip');
    $body = $zip->compress($zipfiles);
    $browser->downloadHeaders($filename . '.zip', 'application/zip', false, strlen($body));
    echo $body;

break;

default:
    echo 'Error';
    break;
}
