<?php
/**
 * This file brings in all of the dependencies that every Usms
 * script will need, and sets up objects that all scripts use.
 *
 * Copyright 2007 Obala d.o.o. (www.obala.si)
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://cvs.horde.org/co.php/news/LICENSE.
 *
 * $Id: base.php 296 2008-01-28 21:07:22Z duck $
 *
 * @author Duck <duck@obala.net>
 * @package Usms
 */

// Check for a prior definition of HORDE_BASE (perhaps by an
// auto_prepend_file definition for site customization).
if (!defined('HORDE_BASE')) {
    define('HORDE_BASE', dirname(__FILE__) . '/../..');
}

// Load the Horde Framework core, and set up inclusion paths and autoloading.
require_once HORDE_BASE . '/lib/core.php';
require_once 'Horde/Loader.php';

// Registry.
$registry = &Registry::singleton();
if (($pushed = $registry->pushApp('usms', !defined('AUTH_HANDLER'))) instanceof PEAR_Error) {
    if ($pushed->getCode() == 'permission_denied') {
        Horde::authenticationFailureRedirect();
    }
    Horde::fatal($pushed, __FILE__, __LINE__, false);
}
$conf = $GLOBALS['conf'];
define('USMS_TEMPLATES', $registry->get('templates'));

// Notification system.
$notification = &Notification::singleton();
$notification->attach('status');

// Define the base file path of Usms.
if (!defined('USMS_BASE')) {
    define('USMS_BASE', dirname(__FILE__) . '/..');
}

// Usms base library
require_once USMS_BASE . '/lib/Usms.php';
require_once USMS_BASE . '/lib/Driver.php';
$GLOBALS['usms'] = Usms_Driver::singleton();

// Cache
$cache = &Horde_Cache::singleton($GLOBALS['conf']['cache']['driver'],
                                 Horde::getDriverConfig('cache', $GLOBALS['conf']['cache']['driver']));

// Start compression.
if (!Util::nonInputVar('no_compress')) {
    Horde::compressOutput();
}
